=== debian/changelog ===
ros-ardent-pendulum-control (0.4.0-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Jackie Kay <jackie@osrfoundation.org>  Sat, 09 Dec 2017 08:13:57 -0000
