=== debian/control ===
Source: ros-ardent-pendulum-control
Section: misc
Priority: extra
Maintainer: Jackie Kay <jackie@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-ardent-ament-cmake, ros-ardent-ament-cmake-pytest, ros-ardent-ament-lint-auto, ros-ardent-ament-lint-common, ros-ardent-launch, ros-ardent-launch-testing, ros-ardent-pendulum-msgs, ros-ardent-rclcpp, ros-ardent-rmw-implementation-cmake, ros-ardent-ros2run, ros-ardent-rttest, ros-ardent-tlsf-cpp, ros-ardent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-ardent-pendulum-control
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-ardent-pendulum-msgs, ros-ardent-rclcpp, ros-ardent-rttest, ros-ardent-tlsf-cpp, ros-ardent-ros-workspace
Description: Demonstrates ROS 2's realtime capabilities with a simulated inverted pendulum.
